// ZweiDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Zwei.h"
#include "ZweiDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZweiDlg Dialogfeld

CZweiDlg::CZweiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZweiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZweiDlg)
	m_Anzahl = 10;
	m_Drehung = _T("");
	m_Takt = 0;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CZweiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZweiDlg)
	DDX_Text(pDX, IDC_EDIT_ANZAHL, m_Anzahl);
	DDV_MinMaxInt(pDX, m_Anzahl, 2, 100);
	DDX_Text(pDX, IDC_EDIT_DREHUNG, m_Drehung);
	DDV_MaxChars(pDX, m_Drehung, 100);
	DDX_Text(pDX, IDC_EDIT_TAKT, m_Takt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZweiDlg, CDialog)
	//{{AFX_MSG_MAP(CZweiDlg)
	ON_BN_CLICKED(IDC_BUTTON_ZUFALL, OnButtonZufall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZweiDlg Nachrichten-Handler

BOOL CZweiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	OnButtonZufall();
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


// Takt ausfhren
void CZweiDlg::OnOK() 
{
	// bentigte Informationen aus der Dialogbox holen
	UpdateData(true);

	// alle Buchstaben auf Kleinschreibung umstellen
	m_Drehung.MakeLower();
	// zwischenspeichern
	CString m_Neu = m_Drehung;

	// alle Buchstaben durchlaufen
	for (int i=0; i<m_Drehung.GetLength()-1; i++)
		// gucken sich zwei benachbarte Soldaten an ?
		if ((m_Drehung[i]=='r')&&
			(m_Drehung[i+1]=='l'))
		{
			// ja, beide um 180 Grad drehen
			m_Neu.SetAt(i,'l');
			m_Neu.SetAt(i+1,'r');
		}

	// prfen, ob Formation unverndert
	if (m_Drehung==m_Neu)
		// Ende
		MessageBox("Keine weiteren Drehungen mehr.","Ergebnis");
	else
	{
		// Takt vollzogen
		m_Drehung = m_Neu;
		m_Takt++;
	}

	// Dialog aktualisieren
	UpdateData(false);
}


// zufllige Formation erstellen
void CZweiDlg::OnButtonZufall() 
{
	// bentigte Informationen aus der Dialogbox holen
	UpdateData(true);

	// Daten initialisieren
	m_Drehung = "";
	m_Takt = 0;

	// Zufallsgenerator einstellen
	srand(time(NULL));

	// Formation entwerfen
	for (int i=0; i<m_Anzahl; i++)
	{
		// Zufallszahlen von 0 bis 32767, also Mitte whlen
		if (rand()<16384)
			m_Drehung+="l";
		else
			m_Drehung+="r";
	}

	// Dialog aktualisieren
	UpdateData(false);
}